using System;
using ofacDemo.Wrapper;
using System.Configuration;
using Autoscribe.Lyons.OFACServiceContract;

namespace ofacDemo
{
    public class demoService
    {
        public const string CFG_LOGON_USERNAME = "userName";
        public const string CFG_LOGON_COMPANYID = "companyID";
        public const string CFG_LOGON_PASSWORD = "userPassword";
        public const string CFG_TEST_NAME = "demoName";
        public const string CFG_TEST_COUNTRY = "demoCountry";

        private IOFACWrapper ofacSvc = new OFACWrapper();

        public string GetAppSetting(string key)
        {
            string res = null;
            try
            {
                res = ConfigurationManager.AppSettings[key];
            }
            catch { }
            return res;
        }

        public bool OFACAllScans()
        {
            bool status = false;
            string userName = GetAppSetting(CFG_LOGON_USERNAME);
            string password = GetAppSetting(CFG_LOGON_PASSWORD);
            int companyId = Int32.Parse(GetAppSetting(CFG_LOGON_COMPANYID));
            string name = GetAppSetting(CFG_TEST_NAME);
            string country = GetAppSetting(CFG_TEST_COUNTRY);
            int listCount = 0;


            try
            {
                // Logon
                string token = ofacSvc.Logon(companyId, userName, password).Token;

                // TESTS
                // OFAC Logon Scan Name
                EntityListResult GetOFACLogonScanTest = ofacSvc.OFACLogonScanName(companyId, userName, password, name);
                Console.WriteLine("OFACLogonScanName:");
                if (GetOFACLogonScanTest.ErrorMesssage == null)
                {
                    if (GetOFACLogonScanTest != null && GetOFACLogonScanTest.Entities != null)
                    {
                        listCount = (GetOFACLogonScanTest.Entities.Count > 10 ? 10 : GetOFACLogonScanTest.Entities.Count);
                        for (int i = 0; i < listCount; i++)
                        {
                            Entity item = GetOFACLogonScanTest.Entities[i];
                            Console.WriteLine(String.Format("  OFAC({0}): {1} {2}", i, item.FullName, item.Score));
                        }
                    }
                }
                else
                    Console.WriteLine(String.Format(" OFACLogonScanName: has error {0}", GetOFACLogonScanTest.ErrorMesssage));

                // OFAC Scan Name
                EntityListResult GetOFACScanNameTest = ofacSvc.OFACScanName(token, name);
                Console.WriteLine("OFACScanName:");
                if (GetOFACScanNameTest.ErrorMesssage == null)
                {
                    if (GetOFACScanNameTest != null && GetOFACScanNameTest.Entities != null)
                    {
                        listCount = (GetOFACScanNameTest.Entities.Count > 10 ? 10 : GetOFACScanNameTest.Entities.Count);
                        for (int i = 0; i < listCount; i++)
                        {
                            Entity item = GetOFACScanNameTest.Entities[i];
                            Console.WriteLine(String.Format("  OFAC({0}): {1} {2}", i, item.FullName, item.Score));
                        }
                    }
                }
                else
                    Console.WriteLine(String.Format(" OFACScanName: has error {0}", GetOFACScanNameTest.ErrorMesssage));

                // OFAC Scan Country
                EntityListResult GetOFACScanCountryTest = ofacSvc.OFACScanCountry(token, name, country);
                Console.WriteLine("OFACScanCountry:");
                if (GetOFACScanNameTest.ErrorMesssage == null)
                {                    
                    if (GetOFACScanCountryTest != null && GetOFACScanCountryTest.Entities != null)
                    {
                        listCount = (GetOFACScanCountryTest.Entities.Count > 10 ? 10 : GetOFACScanCountryTest.Entities.Count);
                        for (int i = 0; i < listCount; i++)
                        {
                            Entity item = GetOFACScanCountryTest.Entities[i];
                            Console.WriteLine(String.Format("  OFAC({0}): {1} {2}", i, item.FullName, item.Score));
                        }
                    }
                }
                else
                    Console.WriteLine(String.Format(" OFACScanCountry: has error {0}", GetOFACScanCountryTest.ErrorMesssage));

                // Country List
                CountryListResult GetCountryListTest = ofacSvc.GetCountryList(token);
                Console.WriteLine("CountryList:");
                if (GetCountryListTest != null && GetCountryListTest.Countries != null)
                {                    
                    listCount = (GetCountryListTest.Countries.Count > 10 ? 10 : GetCountryListTest.Countries.Count);
                    for (int i = 0; i < listCount; i++)
                    {
                        Country item = GetCountryListTest.Countries[i];
                        Console.WriteLine(String.Format("  OFAC({0}): {1} {2}", i, item.Name, item.Code));
                    }
                }
                else
                    Console.WriteLine(String.Format(" CountryList: has error {0}", GetCountryListTest.ErrorMesssage));

                // OFAC Scan Country
                FullEntityListResult GetOFACScanFullRecordTest = ofacSvc.OFACScanNameFullRecord(token, name, country);
                Console.WriteLine("OFACScanCountry:");
                if (GetOFACScanNameTest.ErrorMesssage == null)
                {
                    if (GetOFACScanFullRecordTest != null && GetOFACScanFullRecordTest.Entities != null)
                    {
                        listCount = (GetOFACScanFullRecordTest.Entities.Count > 10 ? 10 : GetOFACScanFullRecordTest.Entities.Count);
                        for (int i = 0; i < listCount; i++)
                        {
                            FullEntity item = GetOFACScanFullRecordTest.Entities[i];
                            Console.WriteLine(String.Format("  OFAC({0}): {1} {2}", i, item.FullName, item.Score));
                        }
                    }
                }
                else
                    Console.WriteLine(String.Format(" OFACScanCountry: has error {0}", GetOFACScanFullRecordTest.ErrorMesssage));


                // LogOff    
                ofacSvc.Logoff(token);
            }
            catch (Exception ex)
            {
                status = false;
                Console.WriteLine(string.Format("---> ERROR: [{0}]", ex.Message));
            }

            return status;
        }

    }
}
